local font = "Interface\\Addons\\bUI\\core\\font.ttf"

local loot_council = {}
-- loot_council_name -> vote_itemID -> vote_playerID
local loot_council_votes = {}
local loot_sessions = {}

local player_name = select(1, UnitName("player"))

function skinBackdrop(frame, ...)
    frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 2})
    frame:SetBackdropColor(...)
    frame:SetBackdropBorderColor(0,0,0,1)
end

--[[function GetItemInfo(item)
	local frame = CreateFrame('frame')
	frame:RegisterEvent("GET_ITEM_INFO_RECEIVED ")
	frame:SetScript("OnEvent", function()
		frame:UnregisterAllEvents();
		frame = nil;
		return GetItemInfo(item);
	end)
	if (GetItemInfo(item) ~= nil) then
		return GetItemInfo(item)
	end
end--]]

function skinButton(frame, text, customwidth)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})

	frame:SetBackdropColor(0,0,0,.5)

	frame:SetHeight(22)
	if (customwidth) then
		frame:SetWidth(customwidth)
	else 
		frame:SetWidth(string.len(text)*9.4)
	end
	frame:SetScript("OnEnter", function()
		frame:SetBackdropColor(0,0,0,.9)
	end)
	frame:SetScript("OnLeave", function()
		frame:SetBackdropColor(0,0,0,.5)
	end)
	frame.text = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	frame.text:SetText(text);
	frame.text:SetJustifyH("CENTER");
	frame.text:SetTextColor(1,1,1);
	frame.text:SetPoint("CENTER", frame, "CENTER", 0, 0)
end

function getRaidIndex(unit) 
	if (UnitInRaid(unit)) then
		return UnitInRaid(unit)
	else 
		return 1
	end
end

-- Frame recycling
--[[ local frame_cache = {}
local function AquireFrame(frame, blank, parent)
	local frame = tremove(frame_cache) or CreateFrame("Frame", nil, parent)
	frame:SetParent(parent)
	return frame
end   --]]
local function ReleaseFrame(frame)
	if (frame ~= nil) then
		frame:UnregisterAllEvents()
		frame:SetParent(nil)
		frame:Hide()
		local children = {frame:GetChildren()}
		for i = 1, #children do
			if (table.getn{children[i]:GetChildren()} > 0) then
				local children2 = {children[i]:GetChildren()}
				for v = 1, #children2 do

					if (table.getn{children2[v]:GetChildren()} > 0) then
						local children3 = {children2[v]:GetChildren()}
						for c = 1, #children3 do
							children3[c]:SetParent(nil)
							children3[c]:Hide()
							children3[c] = nil
						end
					end
					children2[v]:SetParent(nil)
					children2[v]:Hide()
					children2[v] = nil
				end
			end
			
			children[i]:SetParent(nil)
			children[i]:Hide()
			children[i] = nil
		end
		frame = nil 
	end
	
	collectgarbage()
end

local function split(str, del)
	local t = {}
	local index = 0;
	while (string.find(str, ":")) do
		local s, e = string.find(str, ":")
		t[index] = string.sub(str, 1, s-1)
		str = string.sub(str, s+1)
		index = index + 1;
	end
	table.insert(t, str)
	return t;
end

local function tableRemoveKey(t, key)
	local newtable = {}
	for i = 1, #t do
		if (t[i] ~= key) then
			table.insert(newtable, t[i])
		end
	end
	return newtable;
end

local function tableFind(t, f)
	for _,v in pairs(t) do
		if v == f then
			return true
		end
	end
end

-- Construct your saarch pattern based on the existing global string: THANKS PHANX
local scantip = CreateFrame("GameTooltip", "MyScanningTooltip", nil, "GameTooltipTemplate")
scantip:SetOwner(UIParent, "ANCHOR_NONE")

local function GetItemUpgradeLevel(itemLink)
    scantip:SetHyperlink(itemLink)

	local children = {scantip:GetChildren()}
	local text = _G["MyScanningTooltipTextLeft"..3]:GetText()
	if (text and text ~= nil) then
		if (string.find(text, "Item Level") ~= nil) then
			return string.gsub(text, "Item Level ", "")
		else
			return string.gsub(_G["MyScanningTooltipTextLeft"..2]:GetText(), "Item Level ", "")
		end
	else
		return nil
	end
end

local playerilvl = 0
local function getUnitItemLevel(unitID)
	if (playerilvl == 0) then
		local total = 0;
		local num = 0;
		for i = 1, 17 do
			local itemID = GetInventoryItemLink(unitID, i)
			if (itemID and i ~= 4) then
				local ilvl = GetItemUpgradeLevel(itemID)
				if (ilvl) then
					num = num + 1
					total = total + ilvl
				end
			end
		end
		playerilvl = math.floor(total/num);
		return math.floor(total/num);
	else
		return playerilvl;
	end
end

local function inLC()
	return loot_council[select(1, UnitName("player"))]
end

local function destroy_frame(frame)
	ReleaseFrame(frame);
end

local bdlc = CreateFrame('frame');
bdlc:RegisterEvent("ADDON_LOADED");
bdlc:SetScript("OnEvent", function(self, event, arg1)

	if (event == "ADDON_LOADED" and arg1 == "BDLC") then
		print("|cff3399FFBig Dumb Loot Council|r loaded. /bdlc for options")
		bdlc:UnregisterEvent("ADDON_LOADED");
		
		--------------------------------------------------------------------------------
		-- Load configuration or set defaults
		--------------------------------------------------------------------------------
		
		guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
		if (guildRankIndex <= bdlc_config.council_min_rank) then
			loot_council[player_name] = true
		end
		local message_prefix = "BDLC";
		RegisterAddonMessagePrefix(message_prefix);
		
		
		--local tab_frames = {}
		--local roll_frames = {}
		--local vote_frames = {}
		--local entry_frames = {}
		
		if (not bdlc_config) then
			bdlc_config = {
				auto_start = true,
				multiple_votes = false,
				vote_self = true,
				width = 600, 
				height = 400,
				council_min_rank = 1
			}
		end
		
		local sample_items = {113953,113862,113863}
		
		
		bdlc:RegisterEvent("PARTY_CONVERTED_TO_RAID");
		bdlc:RegisterEvent("PLAYER_ENTERING_WORLD");
		bdlc:RegisterEvent("RAID_ROSTER_UPDATE");
		bdlc:RegisterEvent("GUILD_ROSTER_UPDATE");
		bdlc:SetScript("OnEvent", function(self, event, arg1)
			--------------------------------------------------------------------------------
			-- Build the Loot Council
			--------------------------------------------------------------------------------
			local raid_index = getRaidIndex("player");
			--guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
			guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
			if (guildRankIndex <= bdlc_config.council_min_rank) then
				SendAddonMessage(message_prefix, "addToLC:"..player_name, "RAID");
			end
		end)
		
		--------------------------------------------------------------------------------
		-- Create Frames
		--------------------------------------------------------------------------------
		-- Roll Frame
		local roll_frame = CreateFrame("frame", "BLCD Roll Frame", UIParent);
		roll_frame:SetSize(340, 20)
		roll_frame:SetPoint("CENTER", UIParent, "CENTER", 600, 0)
		roll_frame:EnableMouse(true)
		roll_frame:SetMovable(true);
		roll_frame:SetUserPlaced(true);
		roll_frame:SetFrameStrata("HIGH");
		roll_frame:SetClampedToScreen(true);
		roll_frame:RegisterForDrag("LeftButton","RightButton")
		roll_frame:SetScript("OnDragStart", function(self) roll_frame:StartMoving() end)
		roll_frame:SetScript("OnDragStop", function(self) roll_frame:StopMovingOrSizing() end)
		roll_frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 0})
		roll_frame:SetBackdropColor(.2,.2,.3,0.8)
		roll_frame:Hide()
		
		-- Vote Parent frame
		local vote_frame = CreateFrame("frame", "BLCD Vote Frame", UIParent);
		if (inLC()) then
			skinBackdrop(vote_frame, .1,.1,.1,.8);
			vote_frame:EnableMouse(true);
			vote_frame:SetResizable(true);
			vote_frame:SetMovable(true);
			vote_frame:SetUserPlaced(true);
			vote_frame:SetClampedToScreen(true);
			vote_frame:SetMinResize(600, 400);
			vote_frame:SetSize(bdlc_config.width, bdlc_config.height);
			vote_frame:SetPoint("CENTER");
			vote_frame:Hide()
			
			-- Resize Button
			vote_frame.resize = CreateFrame("frame", nil, vote_frame);
			vote_frame.resize:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 0})
			vote_frame.resize:SetBackdropColor(.7,.7,.7,1)
			vote_frame.resize:SetAlpha(.5)
			vote_frame.resize:SetSize(6, 6);
			vote_frame.resize:SetPoint("BOTTOMRIGHT", vote_frame, "BOTTOMRIGHT", -2, 2);
			vote_frame.resize:SetScript("OnEnter", function()
				vote_frame.resize:SetAlpha(1)
			end)
			vote_frame.resize:SetScript("OnLeave", function()
				vote_frame.resize:SetAlpha(.5)
			end)

			vote_frame.resize:EnableMouse(true);
			vote_frame.resize:RegisterForDrag("LeftButton","RightButton")
			vote_frame.resize:SetScript("OnDragStart", function(self) vote_frame:StartSizing() end)
			vote_frame.resize:SetScript("OnDragStop", function(self) 
				vote_frame:StopMovingOrSizing() 
				bdlc_config.width = vote_frame:GetWidth()
				bdlc_config.height =  vote_frame:GetHeight()
			end)
			
			-- Header
			vote_frame.header = CreateFrame("frame", nil, vote_frame);
			vote_frame.header:EnableMouse(true);
			vote_frame.header:RegisterForDrag("LeftButton","RightButton")
			vote_frame.header:SetScript("OnDragStart", function(self) vote_frame:StartMoving() end)
			vote_frame.header:SetScript("OnDragStop", function(self)  vote_frame:StopMovingOrSizing() end)
			
			vote_frame.header.close = CreateFrame("frame", nil, vote_frame.header)
			vote_frame.header.close:SetPoint("RIGHT", vote_frame.header, "RIGHT", -4, 0)
			skinButton(vote_frame.header.close, "x", 20, {.4, .1, .1, .6})
			vote_frame.header.close:SetBackdropColor(.5,.1,.1,.5)
			vote_frame.header.close:EnableMouse(true)
			vote_frame.header.close:SetHeight(20)
			vote_frame.header.close:SetScript("OnMouseUp", function()
				vote_frame:Hide()
			end)
			vote_frame.header.close:SetScript("OnEnter", function()
				vote_frame.header.close:SetBackdropColor(.5,.1,.1,1)
			end)
			vote_frame.header.close:SetScript("OnLeave", function()
				vote_frame.header.close:SetBackdropColor(.5,.1,.1,.5)
			end)
			
			vote_frame.header:SetPoint("TOPLEFT", vote_frame, "TOPLEFT")
			vote_frame.header:SetPoint("BOTTOMRIGHT", vote_frame, "TOPRIGHT", 0, -24)
			vote_frame.header:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 0})
			vote_frame.header:SetBackdropColor(0,0,0,.3)
			
			vote_frame.header.text = vote_frame.header:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			vote_frame.header.text:SetText("|cff3399FFBig Dumb Loot Council|r")
			vote_frame.header.text:SetPoint("CENTER", vote_frame.header, "CENTER")
			
			-- Tabs
			vote_frame.tabs = CreateFrame("frame", nil, vote_frame);
			vote_frame.tabs:SetPoint("TOPLEFT", vote_frame, "TOPLEFT", -60, 0)
			vote_frame.tabs:SetPoint("BOTTOMRIGHT", vote_frame, "BOTTOMLEFT", 0, 0)
		end

		--------------------------------------------------------------------------------
		-- Session functions
		--------------------------------------------------------------------------------
			local function addToLC(playerName)
				loot_council[playerName] = true
			end
		
			local function addUserWant(itemID, raidIndex, want, item1ID, item2ID) 
				if not inLC() then return false end
			
				local entry = _G["vote_entry:"..itemID..":"..raidIndex]
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex)
				local itemName, link1, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture1, vendorPrice = GetItemInfo(item1ID)
				local itemName, link2, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture2, vendorPrice = GetItemInfo(item2ID)

				
				local wantText = "";
				local wantColor = {};
				if (want == "1") then
					wantText = "Mainspec"
					wantColor = {.2, 1, .2};
				elseif (want == "2") then
					wantText = "Minor Up"
					wantColor = {.6, 1, .6};
				elseif (want == "3") then
					wantText = "Offspec"
					wantColor = {.8, .6, .6};
				end

				entry.notes:SetText(wantText);
				entry.notes:SetTextColor(unpack(wantColor));
				
				if (link1) then
					entry.gear1 = CreateFrame("frame", nil, entry)
					entry.gear1:SetSize(20,20);
					entry.gear1:SetPoint("RIGHT", entry, "RIGHT", -230, 0);
					skinBackdrop(entry.gear1, 0, 0, 0, 1)
					
					entry.gear1.tex = entry.gear1:CreateTexture(nil, "OVERLAY")
					entry.gear1.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
					entry.gear1.tex:SetDrawLayer('ARTWORK')
					entry.gear1.tex:SetTexture(texture1)
					entry.gear1.tex:SetPoint("TOPLEFT", entry.gear1, "TOPLEFT", 2, -2)
					entry.gear1.tex:SetPoint("BOTTOMRIGHT", entry.gear1, "BOTTOMRIGHT", -2, 2)
					
					entry.gear1:SetScript("OnEnter", function()
						ShowUIPanel(GameTooltip)
						GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
						GameTooltip:SetHyperlink(link1)
						GameTooltip:Show()
					end)
					entry.gear1:SetScript("OnLeave", function()
						GameTooltip:Hide()
					end)
				end
				
				-- Create 2nd ring and Trinket if necessary
				if (link2) then
					entry.gear2 = CreateFrame("frame", nil, entry)
					entry.gear2:SetSize(20,20);
					entry.gear2:SetPoint("RIGHT", entry, "RIGHT", -200, 0);
					skinBackdrop(entry.gear2, 0, 0, 0, 1)
					
					entry.gear2.tex = entry.gear2:CreateTexture(nil, "OVERLAY")
					entry.gear2.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
					entry.gear2.tex:SetDrawLayer('ARTWORK')
					entry.gear2.tex:SetTexture(texture2)
					entry.gear2.tex:SetPoint("TOPLEFT", entry.gear2, "TOPLEFT", 2, -2)
					entry.gear2.tex:SetPoint("BOTTOMRIGHT", entry.gear2, "BOTTOMRIGHT", -2, 2)
					
					entry.gear2:SetScript("OnEnter", function()
						ShowUIPanel(GameTooltip)
						GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
						GameTooltip:SetHyperlink(link2)
						GameTooltip:Show()
					end)
					entry.gear2:SetScript("OnLeave", function()
						GameTooltip:Hide()
					end)
				end
				
				entry.votes_text = entry:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				entry.votes_text:SetText("0");
				entry.votes_text:SetTextColor(1, 1, 1);
				entry.votes_text:SetPoint("RIGHT", entry, "RIGHT", -130, 0);
				
				-- Create Vote/remove Buttons
				entry.vote_button = CreateFrame("frame", nil, entry)
				entry.vote_button:SetPoint("TOPRIGHT", entry, "TOPRIGHT", -66, 0)
				skinButton(entry.vote_button, "Vote")
				entry.vote_button:SetHeight(20)
				entry.vote_button:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						SendAddonMessage(message_prefix, "voteForUser:"..player_name..":"..itemID..":"..raidIndex, "RAID");
					end
				end)
				
				entry.remove_button = CreateFrame("frame", nil, entry)
				entry.remove_button:SetPoint("TOPRIGHT", entry, "TOPRIGHT", -6, 0)
				skinButton(entry.remove_button, "Remove")
				entry.remove_button:SetHeight(20)
				entry.remove_button:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						SendAddonMessage(message_prefix, "removeUserWant:"..itemID..":"..raidIndex, "RAID");
					end
				end)
			end
			
			local function removeUserWant(itemID, raidIndex) 
				if not inLC() then return false end
				destroy_frame(_G["vote_entry:"..itemID..":"..raidIndex])
			end
			
			local function removeUserConsidering(itemID, raidIndex)
				if not inLC() then return false end
				destroy_frame(_G["vote_entry:"..itemID..":"..raidIndex])
			end
			
			local function addUserConsidering(itemID, raidIndex, iLvL, guildRank)
				if not inLC() then return false end
				
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex)
				local itemName, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemID)
				--local guildName, guildRankName, guildRankIndex = GetGuildInfo(name)
				local class, classFileName = UnitClass(name)
				local color = RAID_CLASS_COLORS[classFileName]
				
				--local vote_table = _G["vote_table:"..itemID];
				local vote_table = _G["vote_frame:"..itemID].table
				local children = table.getn{vote_table:GetChildren()}
				
				-- Create entry in table
				if (inLC) then
					local entry = CreateFrame("frame", "vote_entry:"..itemID..":"..raidIndex, vote_table)
					entry:SetPoint("TOPLEFT", vote_table, "TOPLEFT", 2, -2-((23*children)))
					entry:SetHeight(22)
					entry:SetPoint("TOPRIGHT", vote_table, "TOPRIGHT", -2, 2)
					entry:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 0})
					entry:SetBackdropColor(1,1,1,.1)
					
					--entry = _G["vote_entry:"..itemID..":"..raidIndex]
					
					entry.name = entry:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					entry.name:SetText(name);
					entry.name:SetTextColor(color.r,color.g,color.b);
					entry.name:SetPoint("LEFT", entry, "LEFT", 10, 0)
					
					entry.rank = entry:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					entry.rank:SetText(guildRank);
					entry.rank:SetTextColor(1,1,1);
					entry.rank:SetPoint("LEFT", entry, "LEFT", 80, 0)
					
					entry.ilvl = entry:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					entry.ilvl:SetText(iLvL);
					entry.ilvl:SetTextColor(1,1,1);
					entry.ilvl:SetPoint("LEFT", entry, "LEFT", 176, 0)
					
					entry.notes = entry:CreateFontString(nil, "OVERLAY", "GameFontNormal")
					entry.notes:SetText("considering...");
					entry.notes:SetTextColor(.5,.5,.5);
					entry.notes:SetPoint("LEFT", entry, "LEFT", 208, 0)
				end
			end
			
			local function createVoteWindow(itemID)
				if not inLC() then return false end
				local num_items = table.getn{vote_frame.tabs:GetChildren()}
				local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemID)
				
				-- Vote Area
				vote_frame:Show()
				local frame = CreateFrame("frame", "vote_frame:"..itemID, vote_frame)
				frame:SetPoint("TOPLEFT", vote_frame, "TOPLEFT", 14, -36)
				frame:SetPoint("BOTTOMRIGHT", vote_frame, "BOTTOMRIGHT", -12, 12)
				frame.item = CreateFrame("frame", nil, frame)
				frame.item:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
				frame.item:SetAlpha(1)
				frame.item:SetSize(340, 40)
				
				frame.item:SetScript("OnEnter", function()
					ShowUIPanel(GameTooltip)
					GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
					GameTooltip:SetHyperlink(link)
					GameTooltip:Show()
				end)
				frame.item:SetScript("OnLeave", function()
					GameTooltip:Hide()
				end)
				
				frame.item.itemtext = frame.item:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.item.itemtext:SetText(link)
				frame.item.itemtext:SetPoint("TOPLEFT", frame.item, "TOPLEFT", 50, -6)
				
				frame.item.itemdetail = frame.item:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				local slotname = string.lower(string.gsub(equipSlot, "INVTYPE_", ""));
				slotname = slotname:gsub("^%l", string.upper)
				frame.item.itemdetail:SetText("ilvl: "..iLevel.."    "..subclass..", "..slotname);
				frame.item.itemdetail:SetPoint("BOTTOMLEFT", frame.item, "BOTTOMLEFT", 50, 6)
				
				frame.item.icon = CreateFrame("frame", nil, frame.item)
				frame.item.icon:SetSize(40, 40)
				frame.item.icon:SetPoint("TOPLEFT", frame.item, "TOPLEFT", 0, 0)
				skinBackdrop(frame.item.icon, 0,0,0,.8);
				
				frame.item.icon.tex = frame.item.icon:CreateTexture(nil, "OVERLAY")
				frame.item.icon.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
				frame.item.icon.tex:SetDrawLayer('ARTWORK')
				frame.item.icon.tex:SetTexture(texture)
				frame.item.icon.tex:SetPoint("TOPLEFT", frame.item.icon, "TOPLEFT", 2, -2)
				frame.item.icon.tex:SetPoint("BOTTOMRIGHT", frame.item.icon, "BOTTOMRIGHT", -2, 2)
				
				
				-- Create Item Tabs
				local tab = CreateFrame("frame", "tab_frame:"..itemID, vote_frame.tabs)
				tab:SetSize(60, 60)
				tab:SetPoint("TOPRIGHT", vote_frame.tabs, "TOPRIGHT", 2, -58*num_items)
				tab:SetAlpha(0.5)
				tab:EnableMouse(1)
				skinBackdrop(tab, .1,.1,.1,.8);
				tab:SetScript("OnMouseDown", function(a, b)
					if (b == "LeftButton") then
						for i = 1, #loot_sessions do
							_G["tab_frame:"..loot_sessions[i]]:SetAlpha(.4)
							_G["vote_frame:"..loot_sessions[i]]:Hide()
						end
						tab:SetAlpha(1)
						frame:Show()
					end
				end)
				
				tab.icon = tab:CreateTexture(nil, "OVERLAY")
				tab.icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)
				tab.icon:SetDrawLayer('ARTWORK')
				tab.icon:SetTexture(texture)
				tab.icon:SetPoint("TOPLEFT", tab, "TOPLEFT", 2, -2)
				tab.icon:SetPoint("BOTTOMRIGHT", tab, "BOTTOMRIGHT", -2, 2)
				
				-- Voting table
				frame.table = CreateFrame("frame", nil, frame)
				frame.table:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -70)
				frame.table:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 0)
				skinBackdrop(frame.table, 0,0,0,.2)
				
				frame.table.name_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.name_text:SetText("Name");
				frame.table.name_text:SetTextColor(1, 1, 1);
				frame.table.name_text:SetPoint("TOPLEFT", frame.table, "TOPLEFT", 10, 16);
				
				frame.table.rank_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.rank_text:SetText("Rank");
				frame.table.rank_text:SetTextColor(1, 1, 1);
				frame.table.rank_text:SetPoint("TOPLEFT", frame.table, "TOPLEFT", 80, 16);
				
				frame.table.ilvl_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.ilvl_text:SetText("ilvl");
				frame.table.ilvl_text:SetTextColor(1, 1, 1);
				frame.table.ilvl_text:SetPoint("TOPLEFT", frame.table, "TOPLEFT", 180, 16);
				
				frame.table.ilvl_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.ilvl_text:SetText("Notes");
				frame.table.ilvl_text:SetTextColor(1, 1, 1);
				frame.table.ilvl_text:SetPoint("TOPLEFT", frame.table, "TOPLEFT", 210, 16);
				
				frame.table.current_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.current_text:SetText("Current Gear");
				frame.table.current_text:SetTextColor(1, 1, 1);
				frame.table.current_text:SetPoint("TOPRIGHT", frame.table, "TOPRIGHT", -180, 16);
				
				frame.table.votes_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.votes_text:SetText("Votes");
				frame.table.votes_text:SetTextColor(1, 1, 1);
				frame.table.votes_text:SetPoint("TOPRIGHT", frame.table, "TOPRIGHT", -120, 16);
				
				frame.table.actions_text = frame.table:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				frame.table.actions_text:SetText("Vote   Remove");
				frame.table.actions_text:SetTextColor(1, 1, 1);
				frame.table.actions_text:SetPoint("TOPRIGHT", frame.table, "TOPRIGHT", -10, 16);
				
				-- Buttons
				frame.stop_button = CreateFrame("frame", nil, frame)
				frame.stop_button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -8)
				skinButton(frame.stop_button, "End Voting")
				frame.stop_button:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						SendAddonMessage(message_prefix, "endItemSession:"..itemID, "RAID");
					end
				end)
				
				frame.remove_user = CreateFrame("frame", nil, frame)
				
				

			end
		
			-- Create roll windows
			local function createRollWindow(itemID)
				local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemID)
			
				-- Loop through currently active sessions
				roll_frame:Show()
				local children = table.getn{roll_frame:GetChildren()}
				local roll = CreateFrame("frame", "roll_frame:"..itemID, roll_frame);
				roll:SetPoint("TOPLEFT", roll_frame, "TOPLEFT", 0, -20-(58*children))
				roll:SetSize(340, 60);
				skinBackdrop(roll, .2, .2, .2, .9)
				
				-- Loot item info/hover
				roll.item = CreateFrame("frame", nil, roll);
				roll.item:SetAllPoints(roll);
				roll.item:SetScript("OnEnter", function()
					ShowUIPanel(GameTooltip)
					GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
					GameTooltip:SetHyperlink(link)
					GameTooltip:Show()
				end)
				roll.item:SetScript("OnLeave", function()
					GameTooltip:Hide()
				end)
				roll.item:SetFrameLevel(0)
				
				roll.item.icon = CreateFrame("frame", nil, roll)
				roll.item.icon:SetSize(50, 50)
				roll.item.icon:SetPoint("TOPLEFT", roll, "TOPLEFT", 5, -5)
				skinBackdrop(roll.item.icon, 0,0,0,.8);
				
				roll.item.icon.tex = roll.item.icon:CreateTexture(nil, "OVERLAY")
				roll.item.icon.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
				roll.item.icon.tex:SetDrawLayer('ARTWORK')
				roll.item.icon.tex:SetTexture(texture)
				roll.item.icon.tex:SetPoint("TOPLEFT", roll.item.icon, "TOPLEFT", 2, -2)
				roll.item.icon.tex:SetPoint("BOTTOMRIGHT", roll.item.icon, "BOTTOMRIGHT", -2, 2)
				
				roll.item.item_text = roll:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				roll.item.item_text:SetText(link)
				roll.item.item_text:SetPoint("TOPLEFT", roll, "TOPLEFT", 60, -6)
				roll.item.item_text:SetWidth(300-80)
				roll.item.item_text:SetHeight(20)
				roll.item.item_text:SetJustifyH("LEFT")
				
				roll.item.item_ilvl = roll:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				roll.item.item_ilvl:SetText("ilvl: "..iLevel)
				roll.item.item_ilvl:SetPoint("TOPRIGHT", roll, "TOPRIGHT", -5, -10)
				roll.item.item_ilvl:SetJustifyH("RIGHT")
				
				-- Loot Buttons
				roll.buttons = CreateFrame("frame", nil, roll);
				roll.buttons:SetPoint("BOTTOMLEFT", roll, "BOTTOMLEFT", 50, 0);
				roll.buttons:SetPoint("TOPRIGHT", roll, "BOTTOMRIGHT", 0, 40);
				roll.buttons:EnableMouse(1)
				roll.buttons:SetFrameLevel(1)
				--skinBackdrop(roll.buttons, 0,0,0,1)
				
				local slotID = 0;
				if (equipSlot == "INVTYPE_HEAD") then slotID = 1 end
				if (equipSlot == "INVTYPE_NECK") then slotID = 2 end
				if (equipSlot == "INVTYPE_SHOULDER") then slotID = 3 end
				if (equipSlot == "INVTYPE_BODY") then slotID = 4 end
				if (equipSlot == "INVTYPE_CHEST") then slotID = 5 end
				if (equipSlot == "INVTYPE_WAIST") then slotID = 6 end
				if (equipSlot == "INVTYPE_LEGS") then slotID = 7 end
				if (equipSlot == "INVTYPE_FEET") then slotID = 8 end
				if (equipSlot == "INVTYPE_WRIST") then slotID = 9 end
				if (equipSlot == "INVTYPE_HAND") then slotID = 10 end
				if (equipSlot == "INVTYPE_BACK") then slotID = 15 end
				if (equipSlot == "INVTYPE_OFFHAND") then slotID = 17 end
				if (equipSlot == "INVTYPE_RANGED") then slotID = 18 end
				
				local itemID1 = GetInventoryItemID("player", slotID)
				local itemID2 = 0

				if (equipSlot == "INVTYPE_FINGER") then 
					itemID1 = GetInventoryItemID("player", 11)
					itemID2 = GetInventoryItemID("player", 12)
				end
				if (equipSlot == "INVTYPE_TRINKET") then
					itemID1 = GetInventoryItemID("player", 13)
					itemID2 = GetInventoryItemID("player", 14)
				end
				if (equipSlot == "INVTYPE_WEAPON" or equipSlot == "INVTYPE_2HWEAPON" or equipSlot == "INVTYPE_SHIELD") then
					itemID1 = GetInventoryItemID("player", 16)
					itemID2 = GetInventoryItemID("player", 17)
				end
				
				if (not itemID1) then
					itemID1 = 0
				end
				
				roll.buttons.main = CreateFrame("frame", nil, roll.buttons)
				roll.buttons.main:SetPoint("LEFT", roll.buttons, "LEFT", 10, 0)
				skinButton(roll.buttons.main, "Mainspec")
				roll.buttons.main:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						-- Destroy local roll frames if not interested
						destroy_frame(_G["roll_frame:"..itemID])
						if (table.getn{roll_frame:GetChildren()} == 0) then
							roll_frame:Hide()
						end
						
						--Destroy votability for everyone use using the addo
						SendAddonMessage(message_prefix, "addUserWant:"..itemID..":"..getRaidIndex("player")..":1:"..itemID1..":"..itemID2, "RAID");
					end
				end)
				
				roll.buttons.minor = CreateFrame("frame", nil, roll.buttons)
				roll.buttons.minor:SetPoint("LEFT", roll.buttons, "LEFT", 90, 0)
				skinButton(roll.buttons.minor, "Minor Up")
				roll.buttons.minor:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						-- Destroy local roll frames if not interested
						destroy_frame(_G["roll_frame:"..itemID])
						if (table.getn{roll_frame:GetChildren()} == 0) then
							roll_frame:Hide()
						end
						
						--Destroy votability for everyone use using the addon
						SendAddonMessage(message_prefix, "addUserWant:"..itemID..":"..getRaidIndex("player")..":2:"..itemID1..":"..itemID2, "RAID");
					end
				end)
				
				roll.buttons.off = CreateFrame("frame", nil, roll.buttons)
				roll.buttons.off:SetPoint("LEFT", roll.buttons, "LEFT", 170, 0)
				skinButton(roll.buttons.off, "Offspec")
				roll.buttons.off:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						-- Destroy local roll frames if not interested
						destroy_frame(_G["roll_frame:"..itemID])
						if (table.getn{roll_frame:GetChildren()} == 0) then
							roll_frame:Hide()
						end
						
						--Add votability for everyone use using the addon
						SendAddonMessage(message_prefix, "addUserWant:"..itemID..":"..getRaidIndex("player")..":3:"..itemID1..":"..itemID2, "RAID");
					end
				end)
				
				roll.buttons.pass = CreateFrame("frame", nil, roll.buttons)
				roll.buttons.pass:SetPoint("LEFT", roll.buttons, "LEFT", 240, 0)
				skinButton(roll.buttons.pass, "Pass")
				roll.buttons.pass:SetScript("OnMouseUp", function(a, b)
					if (b == "LeftButton") then
						-- Destroy local roll frames if not interested
						destroy_frame(_G["roll_frame:"..itemID])
						if (table.getn{roll_frame:GetChildren()} == 0) then
							roll_frame:Hide()
						end
						
						--Destroy votability for everyone use using the addon
						SendAddonMessage(message_prefix, "removeUserConsidering:"..itemID..":"..getRaidIndex("player"), "RAID");
					end
				end)
				
				--roll_frames[itemID] = roll
				
				-- Tell everyone that local user is considering the item.,
				local guildRank = select(2, GetGuildInfo("player"))
				--print(guildRank)
				SendAddonMessage(message_prefix, "addUserConsidering:"..itemID..":"..getRaidIndex("player")..":"..getUnitItemLevel("player")..":"..guildRank, "RAID");
			end
			
			local function createSession(itemID)
				-- Create Loot roll window for user
				table.insert(loot_sessions, itemID)

				if (inLC()) then
					createVoteWindow(itemID)
				end
				createRollWindow(itemID, equipSlot)
			end
			
			local function repositionRolls()
				local children = {roll_frame:GetChildren()}
				for i = 1, table.getn(children) do
					children[i]:SetPoint("TOPLEFT", roll_frame, "TOPLEFT", 0, -20-(58*(i-1)))
				end
				if (table.getn({roll_frame:GetChildren()}) == 0) then
					roll_frame:Hide()
				end
			end
			local function repositionTabs()
				if (inLC()) then
					local children = {vote_frame.tabs:GetChildren()}
					for i = 1, table.getn(children) do
						children[i]:SetPoint("TOPRIGHT", vote_frame.tabs, "TOPRIGHT", 2, -58*(i-1))
					end
					if (table.getn({vote_frame.tabs:GetChildren()}) == 0) then
						endEntireSession();
					else
						local lastID = loot_sessions[#loot_sessions]
						for i = 1, #loot_sessions do
							if (loot_sessions[i]) then
								_G["vote_frame:"..loot_sessions[i]]:Hide()
								_G["tab_frame:"..loot_sessions[i]]:SetAlpha(.4)
							end
						end
						
						_G["tab_frame:"..lastID]:SetAlpha(1)
						_G["vote_frame:"..lastID]:Show()
					end
				end
			end
			local function repositionEntries()
				for i = 1, #loot_sessions do
					local children = {vote_table[loot_sessions[i]].table:GetChildren()}
					for v = 1, table.getn(children) do
						children[v]:SetPoint("TOPRIGHT", vote_table[loot_sessions[i]].table, "TOPRIGHT", 2, -58*(v-1))
					end
				end
				
			end
			
			-- Create item session
			local function startSession(itemID)
				local already_added = false
				for v = 1, #loot_sessions do
					if (loot_sessions[v] == itemID) then
						already_added = true
					end
				end
				
				if (not already_added) then
					if (select(2, GetItemInfo(itemID)) ~= nil) then
						createSession(itemID)
						repositionTabs()
					else
						local frame = CreateFrame('frame')
						frame:RegisterEvent('GET_ITEM_INFO_RECEIVED')
						frame:SetScript("OnEvent", function()
							createSession(itemID)
							repositionTabs()
						end)
					end
				end
			end
			
			function endEntireSession()
				local loot_council_votes = {}
				local loot_sessions = {}
				
				vote_frame:Hide()
				roll_frame:Hide()
				
				--for i 
				
				--destroy_frame(_G["tab_frame:"..itemID]);
				--destroy_frame(_G["vote_frame:"..itemID]);
				--destroy_frame(_G["roll_frame:"..itemID]);
			end
			
			local function endItemSession(itemID)
				destroy_frame(_G["tab_frame:"..itemID]);
				destroy_frame(_G["vote_frame:"..itemID]);
				destroy_frame(_G["roll_frame:"..itemID]);

				loot_sessions = tableRemoveKey(loot_sessions, itemID)
			end
			
			
			
			local function voteForUser(councilName, itemID, raidIndex)
				loot_council_votes[councilName] = {[itemID] = raidIndex}
				
				for i = 1, #loot_sessions do
					local vote_table = _G["vote_frame:"..loot_sessions[i]].table
					local children = {vote_table:GetChildren()}
					for i = 1, #children do
						if (children[i].votes_text) then
							children[i].votes_text:SetText(0)
						end
					end
				end
				
				
				table.foreach(loot_council_votes, function(name)
					table.foreach(loot_council_votes[name], function(a, b)
						local entry = _G["vote_entry:"..a..":"..b]
						if (entry.votes_text) then
							entry.votes_text:SetText(entry.votes_text:GetText() + 1)
						end
					end)
				end)
			end
			
			local function startMockSession() 
				SendAddonMessage(message_prefix, "startSession:67109", "RAID", player_name);
				SendAddonMessage(message_prefix, "startSession:46017", "RAID", player_name);
				SendAddonMessage(message_prefix, "startSession:91407", "RAID", player_name);
				SendAddonMessage(message_prefix, "startSession:48032", "RAID", player_name);
			end
		
		--------------------------------------------------------------------------------
		-- Addon message controller
		--------------------------------------------------------------------------------
			
			bdlc.messenger = CreateFrame('frame');
			bdlc.messenger:RegisterEvent('CHAT_MSG_ADDON');
			bdlc.messenger:SetScript("OnEvent", function(event, arg1, arg2, arg3, arg4, arg5)
				if (arg2 == "BDLC") then
					print(arg1..", "..arg2..", "..arg3..", "..arg4..", "..arg5)
					
					local param = split(arg3, ":")
					local action = param[0];
					
					if (action == "syncSession") then
						for i = 1, #loot_sessions do
							startSession(loot_sessions[i])
						end
						--startSession()
					elseif (action == "startSession") then
						startSession(param[1])
						repositionTabs()
						repositionRolls()
					elseif (action == "removeUserConsidering") then
						removeUserConsidering(param[1], param[2])
					elseif (action == "addUserConsidering") then
						addUserConsidering(param[1], param[2], param[3], param[4])
						repositionRolls()
					elseif (action == "addToLC") then
						addToLC(param[1])
					elseif (action == "addUserWant") then
						--print(param[4])
					--print(param[5])
						addUserWant(param[1], param[2], param[3], param[4], param[5])
						repositionRolls()
					elseif (action == "removeUserWant") then
						removeUserWant(param[1], param[2], param[3])
					elseif (action == "voteForUser") then
						voteForUser(param[1], param[2], param[3])
					elseif (action == "endItemSession") then
						endItemSession(param[1])
						repositionTabs()
						repositionRolls()
					else
						
					end
					
					
				end
			end)
			
			bdlc.events = CreateFrame('frame');
			bdlc.events:RegisterEvent("LOOT_OPENED")
			bdlc.events:SetScript("OnEvent", function(event, arg1, arg2)
				local method, partyMaster, raidMaster = GetLootMethod()
				if (method == "master") then
					for slot = 1, GetNumLootItems() do
						local texture, item, quantity, quality, locked = GetLootSlotInfo(slot)

						if (quality > 3) then
							local link = GetLootSlotLink(slot)
							local itemString = string.match(link, "item[%-?%d:]+")
							local _, itemId, enchantId, jewelId1, jewelId2, jewelId3, 
							jewelId4, suffixId, uniqueId, linkLevel, reforgeId = strsplit(":", itemString)
							SendAddonMessage(message_prefix, "startSession:"..itemId, "RAID", player_name);
						end
					end
				end
			end)
		
		--------------------------------------------------------------------------------
		-- For when a user relogs, request any running sessions
		--------------------------------------------------------------------------------
			local function getCurrentSessions() 
				SendAddonMessage(message_prefix, "syncSession", "RAID", player_name);
			end
			-- only run if they're in a raid
			if (getRaidIndex("player")) then
				getCurrentSessions()
			end
		
		--------------------------------------------------------------------------------
		-- Set up slash commands
		--------------------------------------------------------------------------------
		SLASH_BDLC1 = "/bdlc"
		SlashCmdList["BDLC"] = function(msg, editbox)
			if (msg == "" or msg == " ") then
				print("BCLC Options:")
				print("  /bdlc test - Tests the addon (must be in raid)")
				print("  /bdlc show - Shows the vote window (if you're in the LC)")
				print("  /bdlc hide - Hides the vote window (if you're in the LC)")
			elseif (msg == "test") then
				startMockSession()
			elseif (msg == "show" and inLC()) then
				vote_frame:Show()
			elseif (msg == "hide" and inLC()) then
				vote_frame:Hide()
			else
				print(msg)
			end
		end
		
		--------------------------------------------------------------------------------
		-- Create configuration for Interface >> Addons
		--------------------------------------------------------------------------------
	
	
	
		--SendAddonMessage(message_prefix, "test_message", "GUILD");
	end
end)